package com.winhc.bigdata.spark.ng.dynamic

import com.winhc.bigdata.spark.ng.dynamic.utils.CompanyDynamicUtils
import org.apache.spark.internal.Logging

/**
 * @author: XuJiakai
 * @date: 2021/6/23 10:35
 */
trait NgCompanyDynamicHandle extends Serializable with Logging {

  def filter: (String, String, Seq[String], Map[String, String], Map[String, String]) => Boolean = CompanyDynamicUtils.default_filter

  def flat_map: (ChangeExtract) => Seq[CompanyDynamicRecord]


  /**
   * group_by前置处理程。flat_map
   *
   * @return
   */
  def group_by_pre: (CompanyDynamicRecord) => Seq[CompanyDynamicRecord] = null


  def group_by_key: (CompanyDynamicRecord) => String = null

  def group_by_flat_map: (Seq[CompanyDynamicRecord]) => Seq[CompanyDynamicRecord] = null


  protected def getCompanyDynamicRecord(change_extract: ChangeExtract
                                        , dynamic_code: String
                                        , dynamic_info: Map[String, Any]
                                        , update_field: String
                                        , association_entity_info: Seq[AssociationEntityInfo]
                                        , create_time: String = null
                                       ): CompanyDynamicRecord = {
    val tn = change_extract.tn
    val update_type = change_extract.update_type
    val old_data = change_extract.old_data
    val new_data = change_extract.new_data
    val biz_date = change_extract.biz_date
    val rowkey = change_extract.rowkey
    val update_time = change_extract.update_time


    CompanyDynamicRecord(
      id = CompanyDynamicUtils.generateId(rowkey, biz_date, tn, update_field)
      , association_entity_info = association_entity_info
      , rowkey = rowkey
      , tn = tn
      , update_type = update_type
      , dynamic_code = dynamic_code
      , dynamic_info = dynamic_info
      , agg_detail_text = null
      , agg_detail_rowkey = null
      , old_record = old_data
      , new_record = new_data
      , change_time = biz_date
      , update_time = update_time
      , create_time = create_time
    )
  }
}
