package com.winhc.bigdata.spark.ng.dynamic.utils

/**
 * @author ZhangJi
 * @since 2021-07-08 14:28
 */
object DynamicDimConfiguration {
  val DDC = Map(
    "auction_tracking" -> Map(
      "code" -> Map(
        "insert" -> "302901"
      ),
      "sample" -> true,
      "name" -> "司法拍卖",
      "list_field" -> Map(
        "auction_title" -> Map(),
        "initial_price" -> Map(),
        "start_time" -> Map()
      )
    ),
    "company_abnormal_info" -> Map(
      "code" -> Map(
        "insert" -> "301901",
        "update" -> "301902"
      ),
      "sample" -> true,
      "name" -> "经营异常",
      "list_field" -> Map(
        "put_reason" -> Map(),
        "put_department" -> Map(),
        "put_date" -> Map(),
        "remove_reason" -> Map("when" -> "update"),
        "remove_department" -> Map("when" -> "update"),
        "remove_date" -> Map("when" -> "update")
      )
    ),
    "company_court_open_announcement" -> Map(
      "code" -> Map(
        "insert" -> "302101"
      ),
      "sample" -> true,
      "name" -> "开庭公告",
      "list_field" -> Map(
        "start_date" -> Map(),
        "case_no" -> Map(),
        "case_reason" -> Map()
      )
    ),
    "company_env_punishment" -> Map(
      "code" -> Map(
        "insert" -> "302401"
      ),
      "sample" -> true,
      "name" -> "环保处罚",
      "list_field" -> Map(
        "reason" -> Map(),
        "performance" -> Map(),
        "publish_time" -> Map(),
        "content" -> Map()
      )
    ),
    "company_illegal_info" -> Map(
      "code" -> Map(
        "insert" -> "302501"
      ),
      "sample" -> true,
      "name" -> "严重违法",
      "list_field" -> Map(
        "put_reason" -> Map(),
        "put_date" -> Map()
      )
    ),
    "company_own_tax" -> Map(
      "code" -> Map(
        "insert" -> "303001"
      ),
      "sample" -> true,
      "name" -> "欠税公告",
      "list_field" -> Map(
        "own_tax_amount" -> Map(),
        "publish_date" -> Map()
      )
    ),
    "company_punishment_info" -> Map(
      "code" -> Map(
        "insert" -> "302601"
      ),
      "sample" -> true,
      "name" -> "行政处罚",
      "list_field" -> Map(
        "punish_number" -> Map(),
        "content" -> Map(),
        "department_name" -> Map(),
        "decision_date" -> Map()
      )
    ),
    "company_send_announcement" -> Map(
      "code" -> Map(
        "insert" -> "302701"
      ),
      "sample" -> true,
      "name" -> "送达公告",
      "list_field" -> Map(
        "case_no" -> Map(),
        "court" -> Map(),
        "start_date" -> Map()
      )
    ),
    "company_tax_contravention" -> Map(
      "code" -> Map(
        "insert" -> "302801"
      ),
      "sample" -> true,
      "name" -> "税收违法",
      "list_field" -> Map(
        "case_type" -> Map(),
        "publish_time" -> Map()
      )
    ),
    "company_court_announcement" -> Map(
      "code" -> Map(
        "insert" -> "302001"
      ),
      "name" -> "法院公告",
      "list_field" -> Map(
        "announcement_type" -> Map(),
        "litigant" -> Map(
          "type" -> "array",
          "from" -> Seq("plaintiff_info", "litigant_info")
        ),
        "case_no" -> Map()
      )
    ),
    "company_court_register" -> Map(
      "code" -> Map(
        "insert" -> "302201"
      ),
      "name" -> "立案信息",
      "list_field" -> Map(
        "case_reason" -> Map(),
        "filing_date" -> Map(),
        "litigant" -> Map(
          "type" -> "object",
          "from" -> Seq("plaintiff_info", "defendant_info")
        ),
        "case_no" -> Map()
      )
    ),
    "company_punishment_info_creditchina" -> Map(
      "code" -> Map(
        "insert" -> "302601"
      ),

      "name" -> "行政处罚信用中国",
      "list_field" -> Map(
        "punish_number" -> Map(),
        "content" -> Map("from" -> "reason"),
        "department_name" -> Map("from" -> "department"),
        "decision_date" -> Map()
      )
    )
  )

}
