package com.winhc.bigdata.spark.ng.dynamic.utils

import com.winhc.bigdata.spark.implicits.Bool._
import com.winhc.bigdata.spark.ng.dynamic.utils.DynamicDimConfiguration.DDC
import org.json4s._
import org.json4s.jackson.JsonMethods._
import org.json4s.jackson.Serialization

/**
 * @author ZhangJi
 * @since 2021-07-08 10:51
 */
object DynamicFiledUtils {
  val SIMPLE_FILED_CONFIG: Map[String, Map[String, Map[String, Any]]] = DDC.filter(e => e._2.getOrElse("sample", false).asInstanceOf[Boolean]).map(e => (e._1, e._2("list_field").asInstanceOf[Map[String, Map[String, Any]]]))

  def createSimpleDynamicInfo(tn: String, data: Map[String, String], update_type: String = "insert"): (String, Map[String, Any]) = {
    val config = SIMPLE_FILED_CONFIG.getOrElse(tn, Map.empty)
    val filter_set = config.filter(e => e._2.getOrElse("when", "insert").equals(update_type)).map(e => e._2.getOrElse("from", e._1)).toSet
    (DDC(tn)("code").asInstanceOf[Map[String, String]].getOrElse(update_type, null),
      data.filterKeys(e => filter_set.contains(e)))
  }

  def distinctBy[A, B](xs: Seq[A])(f: A => B): List[A] =
    scala.reflect.internal.util.Collections.distinctBy(xs.toList)(f)

  def createDynamicInfo(tn: String, data: Map[String, String]): (String, Map[String, Any]) = {
    val lf = DDC(tn)("list_field").asInstanceOf[Map[String, Map[String, Any]]]
    val dynamicInfo = lf.map(elem => {
      val from = elem._2.getOrElse("from", Seq(elem._1)).asInstanceOf[Seq[String]]
      elem._2.get("type") match {
        case Some("array") => (elem._1, distinctBy(from.flatMap(n => {
          val v = data.getOrElse(n, null)
          var array = parse(v, useBigDecimalForDouble = true).asInstanceOf[JArray]
          array = (array == null) ? new JArray(List.empty[JValue]) | array
          array.arr
        }))(jo => (jo \ "name")))
        case Some("object") => (elem._1, from.map(e => (e.replace("_info", ""), parse(data.getOrElse(e, null)))).toMap)
        case _ => (elem._1, data.getOrElse(from.head, null))
      }
    })
    (DDC(tn)("code").asInstanceOf[Map[String, String]]("insert"), dynamicInfo)
  }


  def main(args: Array[String]): Unit = {
    val str =
      """
        |
        |{
        |   "rowkey": "000074b9fdcdcfc57c6087fe586a9c98",
        |   "litigant_info": "[{\"name\":\"重庆市中强建筑劳务有限公司\",\"litigant_id\":\"9ed161f42fbf7cc25c70873ddfe42896\"},{\"name\":\"中国建筑第二工程局有限公司\",\"litigant_id\":\"25bca6102d624eb7f48846d7468d03a6\"},{\"name\":\"金良\",\"litigant_id\":\"\"}]",
        |   "plaintiff_info": "[{\"name\":\"金良\",\"litigant_id\":\"\"}]",
        |   "defendant_info": "[{\"name\":\"重庆市中强建筑劳务有限公司\",\"litigant_id\":\"9ed161f42fbf7cc25c70873ddfe42896\"},{\"name\":\"中国建筑第二工程局有限公司\",\"litigant_id\":\"25bca6102d624eb7f48846d7468d03a6\"}]",
        |   "third_info": "",
        |   "litigant": "金良,中国建筑第二工程局有限公司,重庆市中强建筑劳务有限公司",
        |   "plaintiff": "金良",
        |   "defendant": "中国建筑第二工程局有限公司,重庆市中强建筑劳务有限公司",
        |   "case_no": "（2016）辽0103民初9478号",
        |   "case_reason": "劳务合同纠纷",
        |   "start_time": null,
        |   "court": "沈阳市沈河区人民法院",
        |   "department": "",
        |   "area": "辽宁",
        |   "assistant": null,
        |   "judge": "",
        |   "third": "",
        |   "filing_date": "2016-08-23 00:00:00",
        |   "close_date": null,
        |   "content": "原告：金良；被告：中国建筑第二工程局有限公司；被告：重庆市中强建筑劳务有限公司；",
        |   "case_status": "结",
        |   "case_type": "",
        |   "source": null,
        |   "source_url": "http://lnsfw.lnsfy.gov.cn/gateway/ssfw/ssfw_app/app/wajjbxx  c393b2ed289e598026575d5ac2fb54d5",
        |   "create_time": "2020-09-05 01:46:04",
        |   "update_time": "2020-09-05 01:46:04",
        |   "deleted": 0
        | }
        |
        |""".stripMargin
    implicit val formats: AnyRef with Formats = Serialization.formats(NoTypeHints)
    val value: Map[String, String] = parse(str).extract[Map[String, String]]

    import com.winhc.bigdata.spark.implicits.CaseClass2JsonHelper._
    val tuple = createDynamicInfo("company_court_register", value)
//    println(tuple._2.toJson())


    var arr =
      """
        | {
        |   "rowkey": "0002604e4ca560ee015174f9d9e7c9e3",
        |   "bltn_no": 1517030100061,
        |   "bltn_status": 1050,
        |   "announcement_type_code": 132,
        |   "announcement_type": "起诉状副本及开庭传票",
        |   "case_no": "（2016）闽0181民初6620号",
        |   "content": "福清市宏路南峰村宅角路20号陈小年：本院受理原告张巧玲与被告陈小年民间借贷纠纷一案，因你无法直接送达，依照《中华人民共和国民事诉讼法》第九十二条的规定，向你公告送达民事起诉状副本、开庭传票等应诉材料。张巧玲诉讼请求如下：判令陈小年偿还张巧玲借款本金人民币12700元整和利息。自公告之日起满60日，即视为送达。提出答辩状的期限和举证期限为公告送达期满后的15日内。待举证期满后定于2017年5月31日上午9时在本院宏路人民法庭公开开庭审理，逾期将依法缺席裁判。",
        |   "court_name": "福清市人民法院",
        |   "deal_grade": "普通",
        |   "judge": "刘芳",
        |   "judge_phone": "非公示项",
        |   "plaintiff_info": "[{\"name\":\"张巧玲\",\"litigant_id\":\"\"},{\"name\":\"张巧玲\",\"litigant_id\":\"\"}]",
        |   "litigant_info": "[{\"name\":\"陈小年\",\"litigant_id\":\"\"}]",
        |   "plaintiff": "张巧玲",
        |   "litigant": "陈小年",
        |   "province": "福建",
        |   "publish_date": "2017-03-05",
        |   "publish_page": "G71",
        |   "appro_type": 0,
        |   "source": 1,
        |   "create_time": "2020-06-03 06:01:37",
        |   "update_time": "2020-09-15 17:00:05",
        |   "deleted": 0
        | }
        |""".stripMargin


    val v2: Map[String, String] = parse(arr).extract[Map[String, String]]

    val t2: (String, Map[String, Any]) = createDynamicInfo("company_court_announcement", v2)
    println(t2._2.toJson())
  }
}
